Panda3D

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | List of all members
TypedReferenceCount Class Reference

A base class for things which need to inherit from both TypedObject and from ReferenceCount. More...

`#include "typedReferenceCount.h"`

Inheritance diagram for TypedReferenceCount:

## Public Member Functions
| TypedReferenceCount (const TypedReferenceCount &copy)
virtual TypeHandle | force_init_type ()
virtual TypeHandle | get_type () const
void | operator= (const TypedReferenceCount &copy)
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer.
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer.
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type.
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly.
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type.
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object.
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise.
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack.
void | ref () const
| Explicitly increments the reference count.
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus.
virtual bool | unref () const
| Explicitly decrements the reference count.
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one.
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object.
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object.

## Static Public Member Functions
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96.
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()

## Additional Inherited Members
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count.

## Detailed Description

A base class for things which need to inherit from both TypedObject and from ReferenceCount.

It's convenient to define this intermediate base class instead of multiply inheriting from the two classes each time they are needed, so that we can sensibly pass around pointers to things which are both TypedObjects and ReferenceCounters.

See also TypedObject for detailed instructions.

Definition at line 31 of file typedReferenceCount.h.

## Constructor & Destructor Documentation

## ◆ TypedReferenceCount() [1/2]

TypedReferenceCount::TypedReferenceCount | ( |  | ) |
| inline

Definition at line 17 of file typedReferenceCount.I.

## ◆ TypedReferenceCount() [2/2]

TypedReferenceCount::TypedReferenceCount | ( | const TypedReferenceCount & | copy | ) |
| inline

Definition at line 27 of file typedReferenceCount.I.

## Member Function Documentation

## ◆ force_init_type()

virtual TypeHandle TypedReferenceCount::force_init_type | ( |  | ) |
| inline virtual

Implements TypedObject.

Definition at line 41 of file typedReferenceCount.h.

## ◆ get_class_type()

static TypeHandle TypedReferenceCount::get_class_type | ( |  | ) |
| inline static

Definition at line 44 of file typedReferenceCount.h.

## ◆ get_type()

virtual TypeHandle TypedReferenceCount::get_type | ( |  | ) | const
| inline virtual

Implements TypedObject.

Definition at line 38 of file typedReferenceCount.h.

## ◆ init_type()

static void TypedReferenceCount::init_type | ( |  | ) |
| inline static

Definition at line 49 of file typedReferenceCount.h.

## ◆ operator=()

void TypedReferenceCount::operator= | ( | const TypedReferenceCount & | copy | ) |
| inline

Definition at line 40 of file typedReferenceCount.I.

The documentation for this class was generated from the following files:

- panda/src/express/typedReferenceCount.h
- panda/src/express/typedReferenceCount.cxx
- panda/src/express/typedReferenceCount.I